<template>
  <div id="patent">
    <admin-frame @search="search" :limit="limit" :total="total" topType="2" @back="back" :rightArrow="false" :useNav="false">
      <template v-slot:info>
        <list-1 :list="list" @toView="toView" @fileCheck="fileCheck" @toGzj="toGzj"></list-1>
      </template>
    </admin-frame>
    <van-dialog class="dialog" v-model="dialog.show" :title="dialog.title" :show-confirm-button="false" show-cancel-button cancel-button-text="返回">
      <info-1 :info="info" v-if="dialog.type == '1'"></info-1>
      <check-1 :form="info" v-else-if="dialog.type == '2'" @onSubmit="oneSubmit"></check-1>
    </van-dialog>
  </div>
</template>

<script>
import list1 from '@/layout/apply/list-1.vue';
import info1 from '@/layout/apply/info-1.vue';
import check1 from '@/layout/apply/check-1.vue';
import adminFrame from '@frame/src/components/mobile-frame/mobile-main.vue';
import { mapState, createNamespacedHelpers } from 'vuex';
const { mapActions: patentapply } = createNamespacedHelpers('patentapply');
export default {
  name: 'patent',
  props: {},
  components: {
    adminFrame,
    list1,
    info1,
    check1,
  },
  data: function () {
    return {
      list: [],
      limit: 5,
      total: 0,
      // 弹框
      dialog: { show: false, title: '详细信息', type: '1' },
      // 详细信息
      info: {},
    };
  },
  async created() {
    await this.search();
  },
  methods: {
    ...patentapply(['query', 'fetch', 'check']),
    async search({ skip = 0, limit = this.limit, ...info } = {}) {
      info.mech_id = this.user._id;
      let res = await this.query({ skip, limit, ...info });
      if (this.$checkRes(res)) {
        this.$set(this, `list`, res.data);
        this.$set(this, `total`, res.total);
      }
    },
    // 查看信息
    async toView(data) {
      let res = await this.fetch(data.id);
      if (this.$checkRes(res)) {
        if (res.data.questions == undefined) res.data.questions = {};
        this.$set(this, `info`, res.data);
        this.dialog = { show: true, title: '详细信息', type: '1' };
      }
    },
    // 文件审批
    fileCheck(data) {
      this.$set(this, `info`, data);
      this.dialog = { show: true, title: '文件审批', type: '2' };
    },
    // 文件审批提交
    async oneSubmit(data) {
      let res = await this.check(data);
      if (this.$checkRes(res)) {
        this.$toast({ type: `success`, message: `操作完成` });
        this.search();
        this.dialog = { show: false, title: '文件审批', type: '2' };
      }
    },
    // 国知局反馈信息
    toGzj(data) {
      this.$router.push({ path: '/patent/user/apply/apply/gzjDetail', query: { name: data.name, create_number: data.create_number } });
    },
    // 返回
    back() {
      this.$router.push({ path: '/patent/index' });
    },
  },
  computed: {
    ...mapState(['user']),
  },
  metaInfo() {
    return { title: this.$route.meta.title };
  },
  watch: {
    test: {
      deep: true,
      immediate: true,
      handler(val) {},
    },
  },
};
</script>

<style lang="less" scoped>
.dialog {
  /deep/.van-dialog__content {
    max-height: 350px;
    overflow-y: auto;
  }
}
</style>
